/*
 *                       Yeppp! library implementation
 *                   This file is auto-generated by Peach-Py,
 *        Portable Efficient Assembly Code-generator in Higher-level Python,
 *                  part of the Yeppp! library infrastructure
 * This file is part of Yeppp! library and licensed under the New BSD license.
 * See library/LICENSE.txt for the full text of the license.
 */

using System.Runtime.InteropServices;

namespace Yeppp
{

	public partial class Core
	{

		public static unsafe void Multiply_V8uV8u_V8u(byte[] xArray, int xOffset, byte[] yArray, int yOffset, byte[] productArray, int productOffset, int length)
		{
			fixed (byte* xPointer = &xArray[xOffset])
			{
				fixed (byte* yPointer = &yArray[yOffset])
				{
					fixed (byte* productPointer = &productArray[productOffset])
					{
						Multiply_V8uV8u_V8u(xPointer, yPointer, productPointer, length);
					}
				}
			}
		}


		public static unsafe void Multiply_V8uV8u_V16u(byte[] xArray, int xOffset, byte[] yArray, int yOffset, ushort[] productArray, int productOffset, int length)
		{
			fixed (byte* xPointer = &xArray[xOffset])
			{
				fixed (byte* yPointer = &yArray[yOffset])
				{
					fixed (ushort* productPointer = &productArray[productOffset])
					{
						Multiply_V8uV8u_V16u(xPointer, yPointer, productPointer, length);
					}
				}
			}
		}


		public static unsafe void Multiply_V8sV8s_V16s(sbyte[] xArray, int xOffset, sbyte[] yArray, int yOffset, short[] productArray, int productOffset, int length)
		{
			fixed (sbyte* xPointer = &xArray[xOffset])
			{
				fixed (sbyte* yPointer = &yArray[yOffset])
				{
					fixed (short* productPointer = &productArray[productOffset])
					{
						Multiply_V8sV8s_V16s(xPointer, yPointer, productPointer, length);
					}
				}
			}
		}


		public static unsafe void Multiply_V16uV16u_V16u(ushort[] xArray, int xOffset, ushort[] yArray, int yOffset, ushort[] productArray, int productOffset, int length)
		{
			fixed (ushort* xPointer = &xArray[xOffset])
			{
				fixed (ushort* yPointer = &yArray[yOffset])
				{
					fixed (ushort* productPointer = &productArray[productOffset])
					{
						Multiply_V16uV16u_V16u(xPointer, yPointer, productPointer, length);
					}
				}
			}
		}


		public static unsafe void Multiply_V16uV16u_V32u(ushort[] xArray, int xOffset, ushort[] yArray, int yOffset, uint[] productArray, int productOffset, int length)
		{
			fixed (ushort* xPointer = &xArray[xOffset])
			{
				fixed (ushort* yPointer = &yArray[yOffset])
				{
					fixed (uint* productPointer = &productArray[productOffset])
					{
						Multiply_V16uV16u_V32u(xPointer, yPointer, productPointer, length);
					}
				}
			}
		}


		public static unsafe void Multiply_V16sV16s_V32s(short[] xArray, int xOffset, short[] yArray, int yOffset, int[] productArray, int productOffset, int length)
		{
			fixed (short* xPointer = &xArray[xOffset])
			{
				fixed (short* yPointer = &yArray[yOffset])
				{
					fixed (int* productPointer = &productArray[productOffset])
					{
						Multiply_V16sV16s_V32s(xPointer, yPointer, productPointer, length);
					}
				}
			}
		}


		public static unsafe void Multiply_V32uV32u_V32u(uint[] xArray, int xOffset, uint[] yArray, int yOffset, uint[] productArray, int productOffset, int length)
		{
			fixed (uint* xPointer = &xArray[xOffset])
			{
				fixed (uint* yPointer = &yArray[yOffset])
				{
					fixed (uint* productPointer = &productArray[productOffset])
					{
						Multiply_V32uV32u_V32u(xPointer, yPointer, productPointer, length);
					}
				}
			}
		}


		public static unsafe void Multiply_V32uV32u_V64u(uint[] xArray, int xOffset, uint[] yArray, int yOffset, ulong[] productArray, int productOffset, int length)
		{
			fixed (uint* xPointer = &xArray[xOffset])
			{
				fixed (uint* yPointer = &yArray[yOffset])
				{
					fixed (ulong* productPointer = &productArray[productOffset])
					{
						Multiply_V32uV32u_V64u(xPointer, yPointer, productPointer, length);
					}
				}
			}
		}


		public static unsafe void Multiply_V32sV32s_V64s(int[] xArray, int xOffset, int[] yArray, int yOffset, long[] productArray, int productOffset, int length)
		{
			fixed (int* xPointer = &xArray[xOffset])
			{
				fixed (int* yPointer = &yArray[yOffset])
				{
					fixed (long* productPointer = &productArray[productOffset])
					{
						Multiply_V32sV32s_V64s(xPointer, yPointer, productPointer, length);
					}
				}
			}
		}


		public static unsafe void Multiply_V64uV64u_V64u(ulong[] xArray, int xOffset, ulong[] yArray, int yOffset, ulong[] productArray, int productOffset, int length)
		{
			fixed (ulong* xPointer = &xArray[xOffset])
			{
				fixed (ulong* yPointer = &yArray[yOffset])
				{
					fixed (ulong* productPointer = &productArray[productOffset])
					{
						Multiply_V64uV64u_V64u(xPointer, yPointer, productPointer, length);
					}
				}
			}
		}


		public static unsafe void Multiply_V32fV32f_V32f(float[] xArray, int xOffset, float[] yArray, int yOffset, float[] productArray, int productOffset, int length)
		{
			fixed (float* xPointer = &xArray[xOffset])
			{
				fixed (float* yPointer = &yArray[yOffset])
				{
					fixed (float* productPointer = &productArray[productOffset])
					{
						Multiply_V32fV32f_V32f(xPointer, yPointer, productPointer, length);
					}
				}
			}
		}


		public static unsafe void Multiply_V64fV64f_V64f(double[] xArray, int xOffset, double[] yArray, int yOffset, double[] productArray, int productOffset, int length)
		{
			fixed (double* xPointer = &xArray[xOffset])
			{
				fixed (double* yPointer = &yArray[yOffset])
				{
					fixed (double* productPointer = &productArray[productOffset])
					{
						Multiply_V64fV64f_V64f(xPointer, yPointer, productPointer, length);
					}
				}
			}
		}


		public static unsafe void Multiply_V8uS8u_V8u(byte[] xArray, int xOffset, byte y, byte[] productArray, int productOffset, int length)
		{
			fixed (byte* xPointer = &xArray[xOffset])
			{
				fixed (byte* productPointer = &productArray[productOffset])
				{
					Multiply_V8uS8u_V8u(xPointer, y, productPointer, length);
				}
			}
		}


		public static unsafe void Multiply_V8uS8u_V16u(byte[] xArray, int xOffset, byte y, ushort[] productArray, int productOffset, int length)
		{
			fixed (byte* xPointer = &xArray[xOffset])
			{
				fixed (ushort* productPointer = &productArray[productOffset])
				{
					Multiply_V8uS8u_V16u(xPointer, y, productPointer, length);
				}
			}
		}


		public static unsafe void Multiply_V8sS8s_V16s(sbyte[] xArray, int xOffset, sbyte y, short[] productArray, int productOffset, int length)
		{
			fixed (sbyte* xPointer = &xArray[xOffset])
			{
				fixed (short* productPointer = &productArray[productOffset])
				{
					Multiply_V8sS8s_V16s(xPointer, y, productPointer, length);
				}
			}
		}


		public static unsafe void Multiply_V16uS16u_V16u(ushort[] xArray, int xOffset, ushort y, ushort[] productArray, int productOffset, int length)
		{
			fixed (ushort* xPointer = &xArray[xOffset])
			{
				fixed (ushort* productPointer = &productArray[productOffset])
				{
					Multiply_V16uS16u_V16u(xPointer, y, productPointer, length);
				}
			}
		}


		public static unsafe void Multiply_V16uS16u_V32u(ushort[] xArray, int xOffset, ushort y, uint[] productArray, int productOffset, int length)
		{
			fixed (ushort* xPointer = &xArray[xOffset])
			{
				fixed (uint* productPointer = &productArray[productOffset])
				{
					Multiply_V16uS16u_V32u(xPointer, y, productPointer, length);
				}
			}
		}


		public static unsafe void Multiply_V16sS16s_V32s(short[] xArray, int xOffset, short y, int[] productArray, int productOffset, int length)
		{
			fixed (short* xPointer = &xArray[xOffset])
			{
				fixed (int* productPointer = &productArray[productOffset])
				{
					Multiply_V16sS16s_V32s(xPointer, y, productPointer, length);
				}
			}
		}


		public static unsafe void Multiply_V32uS32u_V32u(uint[] xArray, int xOffset, uint y, uint[] productArray, int productOffset, int length)
		{
			fixed (uint* xPointer = &xArray[xOffset])
			{
				fixed (uint* productPointer = &productArray[productOffset])
				{
					Multiply_V32uS32u_V32u(xPointer, y, productPointer, length);
				}
			}
		}


		public static unsafe void Multiply_V32uS32u_V64u(uint[] xArray, int xOffset, uint y, ulong[] productArray, int productOffset, int length)
		{
			fixed (uint* xPointer = &xArray[xOffset])
			{
				fixed (ulong* productPointer = &productArray[productOffset])
				{
					Multiply_V32uS32u_V64u(xPointer, y, productPointer, length);
				}
			}
		}


		public static unsafe void Multiply_V32sS32s_V64s(int[] xArray, int xOffset, int y, long[] productArray, int productOffset, int length)
		{
			fixed (int* xPointer = &xArray[xOffset])
			{
				fixed (long* productPointer = &productArray[productOffset])
				{
					Multiply_V32sS32s_V64s(xPointer, y, productPointer, length);
				}
			}
		}


		public static unsafe void Multiply_V64uS64u_V64u(ulong[] xArray, int xOffset, ulong y, ulong[] productArray, int productOffset, int length)
		{
			fixed (ulong* xPointer = &xArray[xOffset])
			{
				fixed (ulong* productPointer = &productArray[productOffset])
				{
					Multiply_V64uS64u_V64u(xPointer, y, productPointer, length);
				}
			}
		}


		public static unsafe void Multiply_V32fS32f_V32f(float[] xArray, int xOffset, float y, float[] productArray, int productOffset, int length)
		{
			fixed (float* xPointer = &xArray[xOffset])
			{
				fixed (float* productPointer = &productArray[productOffset])
				{
					Multiply_V32fS32f_V32f(xPointer, y, productPointer, length);
				}
			}
		}


		public static unsafe void Multiply_V64fS64f_V64f(double[] xArray, int xOffset, double y, double[] productArray, int productOffset, int length)
		{
			fixed (double* xPointer = &xArray[xOffset])
			{
				fixed (double* productPointer = &productArray[productOffset])
				{
					Multiply_V64fS64f_V64f(xPointer, y, productPointer, length);
				}
			}
		}


		public static unsafe void Multiply_IV8uV8u_IV8u(byte[] xArray, int xOffset, byte[] yArray, int yOffset, int length)
		{
			fixed (byte* xPointer = &xArray[xOffset])
			{
				fixed (byte* yPointer = &yArray[yOffset])
				{
					Multiply_IV8uV8u_IV8u(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe void Multiply_IV16uV16u_IV16u(ushort[] xArray, int xOffset, ushort[] yArray, int yOffset, int length)
		{
			fixed (ushort* xPointer = &xArray[xOffset])
			{
				fixed (ushort* yPointer = &yArray[yOffset])
				{
					Multiply_IV16uV16u_IV16u(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe void Multiply_IV32uV32u_IV32u(uint[] xArray, int xOffset, uint[] yArray, int yOffset, int length)
		{
			fixed (uint* xPointer = &xArray[xOffset])
			{
				fixed (uint* yPointer = &yArray[yOffset])
				{
					Multiply_IV32uV32u_IV32u(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe void Multiply_IV64uV64u_IV64u(ulong[] xArray, int xOffset, ulong[] yArray, int yOffset, int length)
		{
			fixed (ulong* xPointer = &xArray[xOffset])
			{
				fixed (ulong* yPointer = &yArray[yOffset])
				{
					Multiply_IV64uV64u_IV64u(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe void Multiply_IV32fV32f_IV32f(float[] xArray, int xOffset, float[] yArray, int yOffset, int length)
		{
			fixed (float* xPointer = &xArray[xOffset])
			{
				fixed (float* yPointer = &yArray[yOffset])
				{
					Multiply_IV32fV32f_IV32f(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe void Multiply_IV64fV64f_IV64f(double[] xArray, int xOffset, double[] yArray, int yOffset, int length)
		{
			fixed (double* xPointer = &xArray[xOffset])
			{
				fixed (double* yPointer = &yArray[yOffset])
				{
					Multiply_IV64fV64f_IV64f(xPointer, yPointer, length);
				}
			}
		}


		public static unsafe void Multiply_IV8uS8u_IV8u(byte[] xArray, int xOffset, byte y, int length)
		{
			fixed (byte* xPointer = &xArray[xOffset])
			{
				Multiply_IV8uS8u_IV8u(xPointer, y, length);
			}
		}


		public static unsafe void Multiply_IV16uS16u_IV16u(ushort[] xArray, int xOffset, ushort y, int length)
		{
			fixed (ushort* xPointer = &xArray[xOffset])
			{
				Multiply_IV16uS16u_IV16u(xPointer, y, length);
			}
		}


		public static unsafe void Multiply_IV32uS32u_IV32u(uint[] xArray, int xOffset, uint y, int length)
		{
			fixed (uint* xPointer = &xArray[xOffset])
			{
				Multiply_IV32uS32u_IV32u(xPointer, y, length);
			}
		}


		public static unsafe void Multiply_IV64uS64u_IV64u(ulong[] xArray, int xOffset, ulong y, int length)
		{
			fixed (ulong* xPointer = &xArray[xOffset])
			{
				Multiply_IV64uS64u_IV64u(xPointer, y, length);
			}
		}


		public static unsafe void Multiply_IV32fS32f_IV32f(float[] xArray, int xOffset, float y, int length)
		{
			fixed (float* xPointer = &xArray[xOffset])
			{
				Multiply_IV32fS32f_IV32f(xPointer, y, length);
			}
		}


		public static unsafe void Multiply_IV64fS64f_IV64f(double[] xArray, int xOffset, double y, int length)
		{
			fixed (double* xPointer = &xArray[xOffset])
			{
				Multiply_IV64fS64f_IV64f(xPointer, y, length);
			}
		}


		public static unsafe void Multiply_V8uV8u_V8u(byte* xPointer, byte* yPointer, byte* productPointer, int length)
		{
			yepCore_Multiply_V8uV8u_V8u(xPointer, yPointer, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V8uV8u_V16u(byte* xPointer, byte* yPointer, ushort* productPointer, int length)
		{
			yepCore_Multiply_V8uV8u_V16u(xPointer, yPointer, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V8sV8s_V16s(sbyte* xPointer, sbyte* yPointer, short* productPointer, int length)
		{
			yepCore_Multiply_V8sV8s_V16s(xPointer, yPointer, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V16uV16u_V16u(ushort* xPointer, ushort* yPointer, ushort* productPointer, int length)
		{
			yepCore_Multiply_V16uV16u_V16u(xPointer, yPointer, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V16uV16u_V32u(ushort* xPointer, ushort* yPointer, uint* productPointer, int length)
		{
			yepCore_Multiply_V16uV16u_V32u(xPointer, yPointer, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V16sV16s_V32s(short* xPointer, short* yPointer, int* productPointer, int length)
		{
			yepCore_Multiply_V16sV16s_V32s(xPointer, yPointer, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V32uV32u_V32u(uint* xPointer, uint* yPointer, uint* productPointer, int length)
		{
			yepCore_Multiply_V32uV32u_V32u(xPointer, yPointer, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V32uV32u_V64u(uint* xPointer, uint* yPointer, ulong* productPointer, int length)
		{
			yepCore_Multiply_V32uV32u_V64u(xPointer, yPointer, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V32sV32s_V64s(int* xPointer, int* yPointer, long* productPointer, int length)
		{
			yepCore_Multiply_V32sV32s_V64s(xPointer, yPointer, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V64uV64u_V64u(ulong* xPointer, ulong* yPointer, ulong* productPointer, int length)
		{
			yepCore_Multiply_V64uV64u_V64u(xPointer, yPointer, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V32fV32f_V32f(float* xPointer, float* yPointer, float* productPointer, int length)
		{
			yepCore_Multiply_V32fV32f_V32f(xPointer, yPointer, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V64fV64f_V64f(double* xPointer, double* yPointer, double* productPointer, int length)
		{
			yepCore_Multiply_V64fV64f_V64f(xPointer, yPointer, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V8uS8u_V8u(byte* xPointer, byte y, byte* productPointer, int length)
		{
			yepCore_Multiply_V8uS8u_V8u(xPointer, y, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V8uS8u_V16u(byte* xPointer, byte y, ushort* productPointer, int length)
		{
			yepCore_Multiply_V8uS8u_V16u(xPointer, y, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V8sS8s_V16s(sbyte* xPointer, sbyte y, short* productPointer, int length)
		{
			yepCore_Multiply_V8sS8s_V16s(xPointer, y, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V16uS16u_V16u(ushort* xPointer, ushort y, ushort* productPointer, int length)
		{
			yepCore_Multiply_V16uS16u_V16u(xPointer, y, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V16uS16u_V32u(ushort* xPointer, ushort y, uint* productPointer, int length)
		{
			yepCore_Multiply_V16uS16u_V32u(xPointer, y, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V16sS16s_V32s(short* xPointer, short y, int* productPointer, int length)
		{
			yepCore_Multiply_V16sS16s_V32s(xPointer, y, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V32uS32u_V32u(uint* xPointer, uint y, uint* productPointer, int length)
		{
			yepCore_Multiply_V32uS32u_V32u(xPointer, y, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V32uS32u_V64u(uint* xPointer, uint y, ulong* productPointer, int length)
		{
			yepCore_Multiply_V32uS32u_V64u(xPointer, y, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V32sS32s_V64s(int* xPointer, int y, long* productPointer, int length)
		{
			yepCore_Multiply_V32sS32s_V64s(xPointer, y, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V64uS64u_V64u(ulong* xPointer, ulong y, ulong* productPointer, int length)
		{
			yepCore_Multiply_V64uS64u_V64u(xPointer, y, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V32fS32f_V32f(float* xPointer, float y, float* productPointer, int length)
		{
			yepCore_Multiply_V32fS32f_V32f(xPointer, y, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_V64fS64f_V64f(double* xPointer, double y, double* productPointer, int length)
		{
			yepCore_Multiply_V64fS64f_V64f(xPointer, y, productPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_IV8uV8u_IV8u(byte* xPointer, byte* yPointer, int length)
		{
			yepCore_Multiply_IV8uV8u_IV8u(xPointer, yPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_IV16uV16u_IV16u(ushort* xPointer, ushort* yPointer, int length)
		{
			yepCore_Multiply_IV16uV16u_IV16u(xPointer, yPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_IV32uV32u_IV32u(uint* xPointer, uint* yPointer, int length)
		{
			yepCore_Multiply_IV32uV32u_IV32u(xPointer, yPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_IV64uV64u_IV64u(ulong* xPointer, ulong* yPointer, int length)
		{
			yepCore_Multiply_IV64uV64u_IV64u(xPointer, yPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_IV32fV32f_IV32f(float* xPointer, float* yPointer, int length)
		{
			yepCore_Multiply_IV32fV32f_IV32f(xPointer, yPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_IV64fV64f_IV64f(double* xPointer, double* yPointer, int length)
		{
			yepCore_Multiply_IV64fV64f_IV64f(xPointer, yPointer, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_IV8uS8u_IV8u(byte* xPointer, byte y, int length)
		{
			yepCore_Multiply_IV8uS8u_IV8u(xPointer, y, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_IV16uS16u_IV16u(ushort* xPointer, ushort y, int length)
		{
			yepCore_Multiply_IV16uS16u_IV16u(xPointer, y, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_IV32uS32u_IV32u(uint* xPointer, uint y, int length)
		{
			yepCore_Multiply_IV32uS32u_IV32u(xPointer, y, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_IV64uS64u_IV64u(ulong* xPointer, ulong y, int length)
		{
			yepCore_Multiply_IV64uS64u_IV64u(xPointer, y, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_IV32fS32f_IV32f(float* xPointer, float y, int length)
		{
			yepCore_Multiply_IV32fS32f_IV32f(xPointer, y, new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void Multiply_IV64fS64f_IV64f(double* xPointer, double y, int length)
		{
			yepCore_Multiply_IV64fS64f_IV64f(xPointer, y, new System.UIntPtr(unchecked((uint) length)));
		}


		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V8uV8u_V8u")]
		private static unsafe extern Status yepCore_Multiply_V8uV8u_V8u(byte* x, byte* y, byte* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V8uV8u_V16u")]
		private static unsafe extern Status yepCore_Multiply_V8uV8u_V16u(byte* x, byte* y, ushort* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V8sV8s_V16s")]
		private static unsafe extern Status yepCore_Multiply_V8sV8s_V16s(sbyte* x, sbyte* y, short* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V16uV16u_V16u")]
		private static unsafe extern Status yepCore_Multiply_V16uV16u_V16u(ushort* x, ushort* y, ushort* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V16uV16u_V32u")]
		private static unsafe extern Status yepCore_Multiply_V16uV16u_V32u(ushort* x, ushort* y, uint* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V16sV16s_V32s")]
		private static unsafe extern Status yepCore_Multiply_V16sV16s_V32s(short* x, short* y, int* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V32uV32u_V32u")]
		private static unsafe extern Status yepCore_Multiply_V32uV32u_V32u(uint* x, uint* y, uint* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V32uV32u_V64u")]
		private static unsafe extern Status yepCore_Multiply_V32uV32u_V64u(uint* x, uint* y, ulong* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V32sV32s_V64s")]
		private static unsafe extern Status yepCore_Multiply_V32sV32s_V64s(int* x, int* y, long* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V64uV64u_V64u")]
		private static unsafe extern Status yepCore_Multiply_V64uV64u_V64u(ulong* x, ulong* y, ulong* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V32fV32f_V32f")]
		private static unsafe extern Status yepCore_Multiply_V32fV32f_V32f(float* x, float* y, float* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V64fV64f_V64f")]
		private static unsafe extern Status yepCore_Multiply_V64fV64f_V64f(double* x, double* y, double* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V8uS8u_V8u")]
		private static unsafe extern Status yepCore_Multiply_V8uS8u_V8u(byte* x, byte y, byte* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V8uS8u_V16u")]
		private static unsafe extern Status yepCore_Multiply_V8uS8u_V16u(byte* x, byte y, ushort* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V8sS8s_V16s")]
		private static unsafe extern Status yepCore_Multiply_V8sS8s_V16s(sbyte* x, sbyte y, short* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V16uS16u_V16u")]
		private static unsafe extern Status yepCore_Multiply_V16uS16u_V16u(ushort* x, ushort y, ushort* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V16uS16u_V32u")]
		private static unsafe extern Status yepCore_Multiply_V16uS16u_V32u(ushort* x, ushort y, uint* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V16sS16s_V32s")]
		private static unsafe extern Status yepCore_Multiply_V16sS16s_V32s(short* x, short y, int* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V32uS32u_V32u")]
		private static unsafe extern Status yepCore_Multiply_V32uS32u_V32u(uint* x, uint y, uint* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V32uS32u_V64u")]
		private static unsafe extern Status yepCore_Multiply_V32uS32u_V64u(uint* x, uint y, ulong* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V32sS32s_V64s")]
		private static unsafe extern Status yepCore_Multiply_V32sS32s_V64s(int* x, int y, long* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V64uS64u_V64u")]
		private static unsafe extern Status yepCore_Multiply_V64uS64u_V64u(ulong* x, ulong y, ulong* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V32fS32f_V32f")]
		private static unsafe extern Status yepCore_Multiply_V32fS32f_V32f(float* x, float y, float* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_V64fS64f_V64f")]
		private static unsafe extern Status yepCore_Multiply_V64fS64f_V64f(double* x, double y, double* product, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_IV8uV8u_IV8u")]
		private static unsafe extern Status yepCore_Multiply_IV8uV8u_IV8u(byte* x, byte* y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_IV16uV16u_IV16u")]
		private static unsafe extern Status yepCore_Multiply_IV16uV16u_IV16u(ushort* x, ushort* y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_IV32uV32u_IV32u")]
		private static unsafe extern Status yepCore_Multiply_IV32uV32u_IV32u(uint* x, uint* y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_IV64uV64u_IV64u")]
		private static unsafe extern Status yepCore_Multiply_IV64uV64u_IV64u(ulong* x, ulong* y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_IV32fV32f_IV32f")]
		private static unsafe extern Status yepCore_Multiply_IV32fV32f_IV32f(float* x, float* y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_IV64fV64f_IV64f")]
		private static unsafe extern Status yepCore_Multiply_IV64fV64f_IV64f(double* x, double* y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_IV8uS8u_IV8u")]
		private static unsafe extern Status yepCore_Multiply_IV8uS8u_IV8u(byte* x, byte y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_IV16uS16u_IV16u")]
		private static unsafe extern Status yepCore_Multiply_IV16uS16u_IV16u(ushort* x, ushort y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_IV32uS32u_IV32u")]
		private static unsafe extern Status yepCore_Multiply_IV32uS32u_IV32u(uint* x, uint y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_IV64uS64u_IV64u")]
		private static unsafe extern Status yepCore_Multiply_IV64uS64u_IV64u(ulong* x, ulong y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_IV32fS32f_IV32f")]
		private static unsafe extern Status yepCore_Multiply_IV32fS32f_IV32f(float* x, float y, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepCore_Multiply_IV64fS64f_IV64f")]
		private static unsafe extern Status yepCore_Multiply_IV64fS64f_IV64f(double* x, double y, System.UIntPtr length);

	}

}
