/*
 *                       Yeppp! library implementation
 *                   This file is auto-generated by Peach-Py,
 *        Portable Efficient Assembly Code-generator in Higher-level Python,
 *                  part of the Yeppp! library infrastructure
 * This file is part of Yeppp! library and licensed under the New BSD license.
 * See library/LICENSE.txt for the full text of the license.
 */

using System.Runtime.InteropServices;

namespace Yeppp
{

	public partial class Math
	{

		public static unsafe void EvaluatePolynomial_V32fV32f_V32f(float[] coefArray, int coefOffset, float[] xArray, int xOffset, float[] yArray, int yOffset, int coefCount, int length)
		{
			fixed (float* coefPointer = &coefArray[coefOffset])
			{
				fixed (float* xPointer = &xArray[xOffset])
				{
					fixed (float* yPointer = &yArray[yOffset])
					{
						EvaluatePolynomial_V32fV32f_V32f(coefPointer, xPointer, yPointer, coefCount, length);
					}
				}
			}
		}


		public static unsafe void EvaluatePolynomial_V64fV64f_V64f(double[] coefArray, int coefOffset, double[] xArray, int xOffset, double[] yArray, int yOffset, int coefCount, int length)
		{
			fixed (double* coefPointer = &coefArray[coefOffset])
			{
				fixed (double* xPointer = &xArray[xOffset])
				{
					fixed (double* yPointer = &yArray[yOffset])
					{
						EvaluatePolynomial_V64fV64f_V64f(coefPointer, xPointer, yPointer, coefCount, length);
					}
				}
			}
		}


		public static unsafe void EvaluatePolynomial_V32fV32f_V32f(float* coefPointer, float* xPointer, float* yPointer, int coefCount, int length)
		{
			yepMath_EvaluatePolynomial_V32fV32f_V32f(coefPointer, xPointer, yPointer, new System.UIntPtr(unchecked((uint) coefCount)), new System.UIntPtr(unchecked((uint) length)));
		}


		public static unsafe void EvaluatePolynomial_V64fV64f_V64f(double* coefPointer, double* xPointer, double* yPointer, int coefCount, int length)
		{
			yepMath_EvaluatePolynomial_V64fV64f_V64f(coefPointer, xPointer, yPointer, new System.UIntPtr(unchecked((uint) coefCount)), new System.UIntPtr(unchecked((uint) length)));
		}


		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepMath_EvaluatePolynomial_V32fV32f_V32f")]
		private static unsafe extern Status yepMath_EvaluatePolynomial_V32fV32f_V32f(float* coef, float* x, float* y, System.UIntPtr coefCount, System.UIntPtr length);

		[DllImport("yeppp", ExactSpelling=true, CallingConvention=CallingConvention.Cdecl, EntryPoint="yepMath_EvaluatePolynomial_V64fV64f_V64f")]
		private static unsafe extern Status yepMath_EvaluatePolynomial_V64fV64f_V64f(double* coef, double* x, double* y, System.UIntPtr coefCount, System.UIntPtr length);

	}

}
