/*
 *                       Yeppp! library implementation
 *                   This file is auto-generated by Peach-Py,
 *        Portable Efficient Assembly Code-generator in Higher-level Python,
 *                  part of the Yeppp! library infrastructure
 * This file is part of Yeppp! library and licensed under the New BSD license.
 * See library/LICENSE.txt for the full text of the license.
 */

package info.yeppp;

/** @brief	Basic arithmetic operations. */
public class Core {
	static {
		System.loadLibrary("yeppp");
		System.loadLibrary("yeppp-jni");
	}

	/** @name	Addition */
	/**@{*/
	public static native void Add_V8uV8u_V8u(byte[] xArray, int xOffset, byte[] yArray, int yOffset, byte[] sumArray, int sumOffset, int length);
	public static native void Add_V8uV8u_V16u(byte[] xArray, int xOffset, byte[] yArray, int yOffset, short[] sumArray, int sumOffset, int length);
	public static native void Add_V8sV8s_V16s(byte[] xArray, int xOffset, byte[] yArray, int yOffset, short[] sumArray, int sumOffset, int length);
	public static native void Add_V16uV16u_V16u(short[] xArray, int xOffset, short[] yArray, int yOffset, short[] sumArray, int sumOffset, int length);
	public static native void Add_V16uV16u_V32u(short[] xArray, int xOffset, short[] yArray, int yOffset, int[] sumArray, int sumOffset, int length);
	public static native void Add_V16sV16s_V32s(short[] xArray, int xOffset, short[] yArray, int yOffset, int[] sumArray, int sumOffset, int length);
	public static native void Add_V32uV32u_V32u(int[] xArray, int xOffset, int[] yArray, int yOffset, int[] sumArray, int sumOffset, int length);
	public static native void Add_V32uV32u_V64u(int[] xArray, int xOffset, int[] yArray, int yOffset, long[] sumArray, int sumOffset, int length);
	public static native void Add_V32sV32s_V64s(int[] xArray, int xOffset, int[] yArray, int yOffset, long[] sumArray, int sumOffset, int length);
	public static native void Add_V64uV64u_V64u(long[] xArray, int xOffset, long[] yArray, int yOffset, long[] sumArray, int sumOffset, int length);
	public static native void Add_V32fV32f_V32f(float[] xArray, int xOffset, float[] yArray, int yOffset, float[] sumArray, int sumOffset, int length);
	public static native void Add_V64fV64f_V64f(double[] xArray, int xOffset, double[] yArray, int yOffset, double[] sumArray, int sumOffset, int length);
	/**@}*/


	/** @name	Subtraction */
	/**@{*/
	public static native void Subtract_V8uV8u_V8u(byte[] xArray, int xOffset, byte[] yArray, int yOffset, byte[] differenceArray, int differenceOffset, int length);
	public static native void Subtract_V8uV8u_V16u(byte[] xArray, int xOffset, byte[] yArray, int yOffset, short[] differenceArray, int differenceOffset, int length);
	public static native void Subtract_V8sV8s_V16s(byte[] xArray, int xOffset, byte[] yArray, int yOffset, short[] differenceArray, int differenceOffset, int length);
	public static native void Subtract_V16uV16u_V16u(short[] xArray, int xOffset, short[] yArray, int yOffset, short[] differenceArray, int differenceOffset, int length);
	public static native void Subtract_V16uV16u_V32u(short[] xArray, int xOffset, short[] yArray, int yOffset, int[] differenceArray, int differenceOffset, int length);
	public static native void Subtract_V16sV16s_V32s(short[] xArray, int xOffset, short[] yArray, int yOffset, int[] differenceArray, int differenceOffset, int length);
	public static native void Subtract_V32uV32u_V32u(int[] xArray, int xOffset, int[] yArray, int yOffset, int[] differenceArray, int differenceOffset, int length);
	public static native void Subtract_V32uV32u_V64u(int[] xArray, int xOffset, int[] yArray, int yOffset, long[] differenceArray, int differenceOffset, int length);
	public static native void Subtract_V32sV32s_V64s(int[] xArray, int xOffset, int[] yArray, int yOffset, long[] differenceArray, int differenceOffset, int length);
	public static native void Subtract_V64uV64u_V64u(long[] xArray, int xOffset, long[] yArray, int yOffset, long[] differenceArray, int differenceOffset, int length);
	public static native void Subtract_V32fV32f_V32f(float[] xArray, int xOffset, float[] yArray, int yOffset, float[] differenceArray, int differenceOffset, int length);
	public static native void Subtract_V64fV64f_V64f(double[] xArray, int xOffset, double[] yArray, int yOffset, double[] differenceArray, int differenceOffset, int length);
	/**@}*/


	/** @name	Multiplication */
	/**@{*/
	public static native void Multiply_V8uV8u_V8u(byte[] xArray, int xOffset, byte[] yArray, int yOffset, byte[] productArray, int productOffset, int length);
	public static native void Multiply_V8uV8u_V16u(byte[] xArray, int xOffset, byte[] yArray, int yOffset, short[] productArray, int productOffset, int length);
	public static native void Multiply_V8sV8s_V16s(byte[] xArray, int xOffset, byte[] yArray, int yOffset, short[] productArray, int productOffset, int length);
	public static native void Multiply_V16uV16u_V16u(short[] xArray, int xOffset, short[] yArray, int yOffset, short[] productArray, int productOffset, int length);
	public static native void Multiply_V16uV16u_V32u(short[] xArray, int xOffset, short[] yArray, int yOffset, int[] productArray, int productOffset, int length);
	public static native void Multiply_V16sV16s_V32s(short[] xArray, int xOffset, short[] yArray, int yOffset, int[] productArray, int productOffset, int length);
	public static native void Multiply_V32uV32u_V32u(int[] xArray, int xOffset, int[] yArray, int yOffset, int[] productArray, int productOffset, int length);
	public static native void Multiply_V32uV32u_V64u(int[] xArray, int xOffset, int[] yArray, int yOffset, long[] productArray, int productOffset, int length);
	public static native void Multiply_V32sV32s_V64s(int[] xArray, int xOffset, int[] yArray, int yOffset, long[] productArray, int productOffset, int length);
	public static native void Multiply_V64uV64u_V64u(long[] xArray, int xOffset, long[] yArray, int yOffset, long[] productArray, int productOffset, int length);
	public static native void Multiply_V32fV32f_V32f(float[] xArray, int xOffset, float[] yArray, int yOffset, float[] productArray, int productOffset, int length);
	public static native void Multiply_V64fV64f_V64f(double[] xArray, int xOffset, double[] yArray, int yOffset, double[] productArray, int productOffset, int length);
	public static native void Multiply_V8uS8u_V8u(byte[] xArray, int xOffset, byte y, byte[] productArray, int productOffset, int length);
	public static native void Multiply_V8uS8u_V16u(byte[] xArray, int xOffset, byte y, short[] productArray, int productOffset, int length);
	public static native void Multiply_V8sS8s_V16s(byte[] xArray, int xOffset, byte y, short[] productArray, int productOffset, int length);
	public static native void Multiply_V16uS16u_V16u(short[] xArray, int xOffset, short y, short[] productArray, int productOffset, int length);
	public static native void Multiply_V16uS16u_V32u(short[] xArray, int xOffset, short y, int[] productArray, int productOffset, int length);
	public static native void Multiply_V16sS16s_V32s(short[] xArray, int xOffset, short y, int[] productArray, int productOffset, int length);
	public static native void Multiply_V32uS32u_V32u(int[] xArray, int xOffset, int y, int[] productArray, int productOffset, int length);
	public static native void Multiply_V32uS32u_V64u(int[] xArray, int xOffset, int y, long[] productArray, int productOffset, int length);
	public static native void Multiply_V32sS32s_V64s(int[] xArray, int xOffset, int y, long[] productArray, int productOffset, int length);
	public static native void Multiply_V64uS64u_V64u(long[] xArray, int xOffset, long y, long[] productArray, int productOffset, int length);
	public static native void Multiply_V32fS32f_V32f(float[] xArray, int xOffset, float y, float[] productArray, int productOffset, int length);
	public static native void Multiply_V64fS64f_V64f(double[] xArray, int xOffset, double y, double[] productArray, int productOffset, int length);
	public static native void Multiply_IV8uV8u_IV8u(byte[] xArray, int xOffset, byte[] yArray, int yOffset, int length);
	public static native void Multiply_IV16uV16u_IV16u(short[] xArray, int xOffset, short[] yArray, int yOffset, int length);
	public static native void Multiply_IV32uV32u_IV32u(int[] xArray, int xOffset, int[] yArray, int yOffset, int length);
	public static native void Multiply_IV64uV64u_IV64u(long[] xArray, int xOffset, long[] yArray, int yOffset, int length);
	public static native void Multiply_IV32fV32f_IV32f(float[] xArray, int xOffset, float[] yArray, int yOffset, int length);
	public static native void Multiply_IV64fV64f_IV64f(double[] xArray, int xOffset, double[] yArray, int yOffset, int length);
	public static native void Multiply_IV8uS8u_IV8u(byte[] xArray, int xOffset, byte y, int length);
	public static native void Multiply_IV16uS16u_IV16u(short[] xArray, int xOffset, short y, int length);
	public static native void Multiply_IV32uS32u_IV32u(int[] xArray, int xOffset, int y, int length);
	public static native void Multiply_IV64uS64u_IV64u(long[] xArray, int xOffset, long y, int length);
	public static native void Multiply_IV32fS32f_IV32f(float[] xArray, int xOffset, float y, int length);
	public static native void Multiply_IV64fS64f_IV64f(double[] xArray, int xOffset, double y, int length);
	/**@}*/


	/** @name	Dot product */
	/**@{*/
	public static native float DotProduct_V32fV32f_S32f(float[] xArray, int xOffset, float[] yArray, int yOffset, int length);
	public static native double DotProduct_V64fV64f_S64f(double[] xArray, int xOffset, double[] yArray, int yOffset, int length);
	/**@}*/


	/** @name	Sum of squares (squared L2 norm) */
	/**@{*/
	public static native float SumSquares_V32f_S32f(float[] vArray, int vOffset, int length);
	public static native double SumSquares_V64f_S64f(double[] vArray, int vOffset, int length);
	/**@}*/


}
