/*
 *                       Yeppp! library implementation
 *                   This file is auto-generated by Peach-Py,
 *        Portable Efficient Assembly Code-generator in Higher-level Python,
 *                  part of the Yeppp! library infrastructure
 * This file is part of Yeppp! library and licensed under the New BSD license.
 * See library/LICENSE.txt for the full text of the license.
 */

#include <jni.h>
#include <yepMath.h>


JNIEXPORT void JNICALL Java_info_yeppp_Math_EvaluatePolynomial_1V32fV32f_1V32f(JNIEnv *env, jclass class, jfloatArray coefArray, jint coefOffset, jfloatArray xArray, jint xOffset, jfloatArray yArray, jint yOffset, jint coefCount, jint length) {
	enum YepStatus status;
	Yep32f* coefPointer = NULL;
	Yep32f* xPointer = NULL;
	Yep32f* yPointer = NULL;

	coefPointer = (*env)->GetPrimitiveArrayCritical(env, coefArray, NULL);
	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepMath_EvaluatePolynomial_V32fV32f_V32f(&coefPointer[coefOffset], &xPointer[xOffset], &yPointer[yOffset], coefCount, length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, coefArray, coefPointer, JNI_ABORT);
}

JNIEXPORT void JNICALL Java_info_yeppp_Math_EvaluatePolynomial_1V64fV64f_1V64f(JNIEnv *env, jclass class, jdoubleArray coefArray, jint coefOffset, jdoubleArray xArray, jint xOffset, jdoubleArray yArray, jint yOffset, jint coefCount, jint length) {
	enum YepStatus status;
	Yep64f* coefPointer = NULL;
	Yep64f* xPointer = NULL;
	Yep64f* yPointer = NULL;

	coefPointer = (*env)->GetPrimitiveArrayCritical(env, coefArray, NULL);
	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepMath_EvaluatePolynomial_V64fV64f_V64f(&coefPointer[coefOffset], &xPointer[xOffset], &yPointer[yOffset], coefCount, length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, coefArray, coefPointer, JNI_ABORT);
}
